"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const utils_1 = require("../../../../utils");
const CallRequest = __importStar(require("./CallRequest"));
const HeaderParameter = __importStar(require("./HeaderParameter"));
const PathParameter = __importStar(require("./PathParameter"));
const QueryParameter = __importStar(require("./QueryParameter"));
const create = (factory, params) => {
    const statements = [];
    const { convertedParams } = params;
    const { pickedParameters } = convertedParams;
    // Generate Path Parameter
    const pathParameters = pickedParameters.filter(PathParameter.isPathParameter);
    statements.push(PathParameter.create(factory, params.operationParams.requestUri, pathParameters));
    const initialHeaderObject = {};
    if (convertedParams.has2OrMoreRequestContentTypes) {
        initialHeaderObject["Content-Type"] = {
            type: "variable",
            value: `params.headers.Content-Type`,
        };
    }
    else if (convertedParams.requestFirstContentType) {
        initialHeaderObject["Content-Type"] = {
            type: "string",
            value: convertedParams.requestFirstContentType,
        };
    }
    if (convertedParams.has2OrMoreSuccessResponseContentTypes) {
        initialHeaderObject["Accept"] = {
            type: "variable",
            value: `params.headers.Accept`,
        };
    }
    else if (convertedParams.successResponseFirstContentType) {
        initialHeaderObject["Accept"] = {
            type: "string",
            value: convertedParams.successResponseFirstContentType,
        };
    }
    // Generate Header Parameter
    const headerParameter = pickedParameters.filter(item => item.in === "header");
    const headerObject = Object.values(headerParameter).reduce((previous, current) => {
        return { ...previous, [current.name]: { type: "variable", value: `params.parameter.${current.name}` } };
    }, initialHeaderObject);
    statements.push(HeaderParameter.create(factory, {
        variableName: "headers",
        object: headerObject,
    }));
    // Generate Query Parameter
    if (convertedParams.hasQueryParameters) {
        const queryParameter = pickedParameters.filter(item => item.in === "query");
        const queryObject = Object.values(queryParameter).reduce((previous, current) => {
            const { text, escaped } = utils_1.escapeText2(current.name);
            const variableDeclaraText = escaped ? `params.parameter[${text}]` : `params.parameter.${text}`;
            return {
                ...previous,
                [current.name]: { type: "variable", value: variableDeclaraText, style: current.style, explode: !!current.explode },
            };
        }, {});
        statements.push(QueryParameter.create(factory, { variableName: "queryParameters", object: queryObject }));
    }
    // Generate CallRequest
    statements.push(factory.ReturnStatement.create({
        expression: CallRequest.create(factory, params),
    }));
    return statements.length == 0 ? [factory.ReturnStatement.create({})] : statements;
};
exports.create = create;
//# sourceMappingURL=index.js.map